#ifndef CALLBACK_H
#define CALLBACK_H

#include <basic-timer.hpp>

// Friend function outside of namespace :
// https://stackoverflow.com/questions/38801608/friend-functions-and-namespaces

extern "C" void TIM6_DAC_IRQHandler();

namespace stm32f072xb {
typedef void (*vTimerInterruptCallback)(void*);

class TimerInterruptCallback {
   public:
	TimerInterruptCallback();
	TimerInterruptCallback(vTimerInterruptCallback callback, int repeat = 1, int delay = 1);
	TimerInterruptCallback(const TimerInterruptCallback& other) = delete;

	void start(uint16_t autoReloadValue = 122, uint16_t prescalerValue = 0xFFFF);

	friend void ::TIM6_DAC_IRQHandler();

   private:
	vTimerInterruptCallback _callback;
	int _currentIteration;
	int _maxIteration;
	int _sleepIteration;
	BasicTimer _timer;

	void handle();
	BasicTimer setupBasicTimer();
};

}  // namespace stm32f072xb

#endif  // CALLBACK_H
